// IESpyView.cpp : implementation of the CIESpyView class
//

#include "stdafx.h"
#include "IESpy.h"

#include "IESpyDoc.h"
#include "IESpyView.h"

#include <mshtmcid.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static BOOL CALLBACK EnumChildWindowProc(HWND hWnd, LPARAM lParam)
{
	const int nBufCount = 100;
	TCHAR szClassName[ nBufCount ];

	if (::GetClassName( hWnd, szClassName, nBufCount ))
	{
		if (::lstrcmp( szClassName, _T("Internet Explorer_Server") ) == 0)
		{
			CIESpyView * pView = reinterpret_cast< CIESpyView * > (lParam);

			// add the hWnd to the view
			pView->AddItem( hWnd );
		}
	}

	return TRUE;
}

static BOOL CALLBACK EnumWindowProc(HWND hWnd, LPARAM lParam)
{
	::EnumChildWindows( hWnd, ::EnumChildWindowProc, lParam );

	const int nBufCount = 100;
	TCHAR szClassName[ nBufCount ];

	if (::GetClassName( hWnd, szClassName, nBufCount ))
	{
		if (::lstrcmp( szClassName, _T("Internet Explorer_Server") ) == 0)
		{
			CIESpyView * pView = reinterpret_cast< CIESpyView * > (lParam);

			// add the hWnd to the view
			pView->AddItem( hWnd );
		}
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CIESpyView

IMPLEMENT_DYNCREATE(CIESpyView, CListView)

BEGIN_MESSAGE_MAP(CIESpyView, CListView)
	//{{AFX_MSG_MAP(CIESpyView)
	ON_COMMAND(ID_SPY_BEGIN, OnSpyBegin)
	ON_COMMAND(ID_SPY_VIEW_SOURCE, OnSpyViewSource)
	ON_UPDATE_COMMAND_UI(ID_SPY_VIEW_SOURCE, OnUpdateSpyViewSource)
	ON_COMMAND(ID_SPY_FIND, OnSpyFind)
	ON_UPDATE_COMMAND_UI(ID_SPY_FIND, OnUpdateSpyFind)
	ON_COMMAND(ID_SPY_ABOUT, OnSpyAbout)
	ON_UPDATE_COMMAND_UI(ID_SPY_ABOUT, OnUpdateSpyAbout)
	ON_COMMAND(ID_SPY_ADD_TO_FAVORITES, OnSpyAddToFavorites)
	ON_UPDATE_COMMAND_UI(ID_SPY_ADD_TO_FAVORITES, OnUpdateSpyAddToFavorites)
	ON_COMMAND(ID_SPY_COPY_SHORTCUT, OnSpyCopyShortcut)
	ON_UPDATE_COMMAND_UI(ID_SPY_COPY_SHORTCUT, OnUpdateSpyCopyShortcut)
	ON_COMMAND(ID_SPY_SAVE_BACKGROUND, OnCmdSaveBackground)
	ON_UPDATE_COMMAND_UI(ID_SPY_SAVE_BACKGROUND, OnUpdateCmdSaveBackground)
	ON_COMMAND(ID_SPY_SET_AS_WALLPAPER, OnSpySetAsWallpaper)
	ON_UPDATE_COMMAND_UI(ID_SPY_SET_AS_WALLPAPER, OnUpdateSpySetAsWallpaper)
	ON_COMMAND(ID_SPY_COPY_BACKGROUND, OnSpyCopyBackground)
	ON_UPDATE_COMMAND_UI(ID_SPY_COPY_BACKGROUND, OnUpdateSpyCopyBackground)
	ON_COMMAND(ID_SPY_CREATE_SHORTCUT, OnSpyCreateShortcut)
	ON_UPDATE_COMMAND_UI(ID_SPY_CREATE_SHORTCUT, OnUpdateSpyCreateShortcut)
	ON_COMMAND(ID_SPY_SET_AS_DESKTOP_ITEM, OnSpySetAsDesktopItem)
	ON_UPDATE_COMMAND_UI(ID_SPY_SET_AS_DESKTOP_ITEM, OnUpdateSpySetAsDesktopItem)
	ON_COMMAND(ID_SPY_REFRESH, OnSpyRefresh)
	ON_UPDATE_COMMAND_UI(ID_SPY_REFRESH, OnUpdateSpyRefresh)
	ON_COMMAND(ID_SPY_BACK, OnSpyBack)
	ON_UPDATE_COMMAND_UI(ID_SPY_BACK, OnUpdateSpyBack)
	ON_COMMAND(ID_SPY_FORWARD, OnSpyForward)
	ON_UPDATE_COMMAND_UI(ID_SPY_FORWARD, OnUpdateSpyForward)
	ON_COMMAND(ID_SPY_STOP, OnSpyStop)
	ON_UPDATE_COMMAND_UI(ID_SPY_STOP, OnUpdateSpyStop)
	ON_COMMAND(ID_SPY_OPEN, OnSpyOpen)
	ON_UPDATE_COMMAND_UI(ID_SPY_OPEN, OnUpdateSpyOpen)
	ON_COMMAND(ID_SPY_NEW, OnSpyNew)
	ON_UPDATE_COMMAND_UI(ID_SPY_NEW, OnUpdateSpyNew)
	ON_COMMAND(ID_SPY_SAVEAS, OnSpySaveas)
	ON_UPDATE_COMMAND_UI(ID_SPY_SAVEAS, OnUpdateSpySaveas)
	ON_COMMAND(ID_SPY_PRINT_PREVIEW, OnSpyPrintPreview)
	ON_UPDATE_COMMAND_UI(ID_SPY_PRINT_PREVIEW, OnUpdateSpyPrintPreview)
	ON_COMMAND(ID_SPY_PRINT, OnSpyPrint)
	ON_UPDATE_COMMAND_UI(ID_SPY_PRINT, OnUpdateSpyPrint)
	ON_COMMAND(ID_SPY_PAGE_SETUP, OnSpyPageSetup)
	ON_UPDATE_COMMAND_UI(ID_SPY_PAGE_SETUP, OnUpdateSpyPageSetup)
	ON_COMMAND(ID_SPY_PROPERTIES, OnSpyProperties)
	ON_UPDATE_COMMAND_UI(ID_SPY_PROPERTIES, OnUpdateSpyProperties)
	ON_COMMAND(ID_SPY_SELECT_ALL, OnSpySelectAll)
	ON_UPDATE_COMMAND_UI(ID_SPY_SELECT_ALL, OnUpdateSpySelectAll)
	ON_COMMAND(ID_SPY_COPY, OnSpyCopy)
	ON_UPDATE_COMMAND_UI(ID_SPY_COPY, OnUpdateSpyCopy)
	ON_COMMAND(ID_SPY_CUT, OnSpyCut)
	ON_UPDATE_COMMAND_UI(ID_SPY_CUT, OnUpdateSpyCut)
	ON_COMMAND(ID_SPY_PASTE, OnSpyPaste)
	ON_UPDATE_COMMAND_UI(ID_SPY_PASTE, OnUpdateSpyPaste)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CIESpyView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	CListCtrl & list = GetListCtrl();

	list.ModifyStyle( 0, LVS_LIST | LVS_SHOWSELALWAYS | LVS_SINGLESEL | LVS_SORTASCENDING
		| WS_HSCROLL | WS_VSCROLL );
}

/////////////////////////////////////////////////////////////////////////////
// CIESpyView message handlers

void CIESpyView::OnSpyBegin() 
{
	GetListCtrl().DeleteAllItems();

	::EnumWindows( ::EnumWindowProc, reinterpret_cast< LPARAM > (this) );

	GetListCtrl().SortItems( CIESpyView::CompareFunction, reinterpret_cast< DWORD >
		(&GetListCtrl()) );
}

void CIESpyView::AddItem(HWND hWnd)
{
	CString strItem;
	strItem.Format( _T("Internet Explorer window found, HWND = 0x%0.8X     (%0d)"), hWnd, hWnd );

	GetListCtrl().InsertItem( GetListCtrl().GetItemCount(), (LPCTSTR) strItem );
}

int CALLBACK CIESpyView::CompareFunction(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CListCtrl * pListCtrl = reinterpret_cast< CListCtrl * > (lParamSort);

	CString str1 = pListCtrl->GetItemText( lParam1, 0 );
	CString str2 = pListCtrl->GetItemText( lParam2, 0 );

	return str1.Compare( (LPCTSTR) str2 );
}

void CIESpyView::OnSpyViewSource() 
{
	PostMsgHelper( IDM_VIEWSOURCE );
}

void CIESpyView::OnUpdateSpyViewSource(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::PostMsgHelper(DWORD dw)
{
	CListCtrl & list = GetListCtrl();

	POSITION pos = list.GetFirstSelectedItemPosition();
	ASSERT(pos);
	if (!pos)
		return;
	int nIndex = list.GetNextSelectedItem( pos );

	CString strItem = list.GetItemText( nIndex, 0 );
	LPCTSTR psz = ((LPCTSTR) strItem) + 39;
	TCHAR * pchEnd = NULL;

	ULONG ul = ::_tcstoul( psz, &pchEnd, 0 );
	ASSERT(*pchEnd == _T(' '));

	HWND hwnd = reinterpret_cast< HWND > (ul);

	::PostMessage( hwnd, WM_COMMAND, MAKEWPARAM(LOWORD(dw), 0x0), 0 );
}

void CIESpyView::CommonUpdateHandler(CCmdUI *pCmdUI)
{
	if (GetListCtrl().GetItemCount() == 0)
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( GetListCtrl().GetSelectedCount() == 1 );
}

void CIESpyView::OnSpyFind() 
{
	PostMsgHelper( IDM_FIND );
}

void CIESpyView::OnUpdateSpyFind(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyAbout() 
{
	PostMsgHelper( IDM_HELP_ABOUT );
}

void CIESpyView::OnUpdateSpyAbout(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyAddToFavorites() 
{
	PostMsgHelper( IDM_ADDFAVORITES );
}

void CIESpyView::OnUpdateSpyAddToFavorites(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyCopyShortcut() 
{
	PostMsgHelper( IDM_COPYSHORTCUT );
}

void CIESpyView::OnUpdateSpyCopyShortcut(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnCmdSaveBackground() 
{
	PostMsgHelper( IDM_SAVEBACKGROUND );
}

void CIESpyView::OnUpdateCmdSaveBackground(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpySetAsWallpaper() 
{
	PostMsgHelper( IDM_SETWALLPAPER );
}

void CIESpyView::OnUpdateSpySetAsWallpaper(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyCopyBackground() 
{
	PostMsgHelper( IDM_COPYBACKGROUND );
}

void CIESpyView::OnUpdateSpyCopyBackground(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyCreateShortcut() 
{
	PostMsgHelper( IDM_CREATESHORTCUT );
}

void CIESpyView::OnUpdateSpyCreateShortcut(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpySetAsDesktopItem() 
{
	PostMsgHelper( IDM_SETDESKTOPITEM );
}

void CIESpyView::OnUpdateSpySetAsDesktopItem(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyRefresh() 
{
	PostMsgHelper( IDM_REFRESH );
}

void CIESpyView::OnUpdateSpyRefresh(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyBack() 
{
	PostMsgHelper( IDM_GOBACKWARD );
}

void CIESpyView::OnUpdateSpyBack(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyForward() 
{
	PostMsgHelper( IDM_GOFORWARD );
}

void CIESpyView::OnUpdateSpyForward(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyStop() 
{
	PostMsgHelper( IDM_STOPDOWNLOAD );
	PostMsgHelper( IDM_STOP );
}

void CIESpyView::OnUpdateSpyStop(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}


void CIESpyView::OnSpyOpen() 
{
	PostMsgHelper( IDM_OPEN );
}

void CIESpyView::OnUpdateSpyOpen(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyNew() 
{
	PostMsgHelper( IDM_NEW );
}

void CIESpyView::OnUpdateSpyNew(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpySaveas() 
{
	PostMsgHelper( IDM_SAVEAS );
}

void CIESpyView::OnUpdateSpySaveas(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyPrintPreview() 
{
	PostMsgHelper( IDM_PRINTPREVIEW );
}

void CIESpyView::OnUpdateSpyPrintPreview(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyPrint() 
{
	PostMsgHelper( IDM_PRINT );
}

void CIESpyView::OnUpdateSpyPrint(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyPageSetup() 
{
	PostMsgHelper( IDM_PAGESETUP );
}

void CIESpyView::OnUpdateSpyPageSetup(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyProperties() 
{
	PostMsgHelper( IDM_PROPERTIES );
}

void CIESpyView::OnUpdateSpyProperties(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpySelectAll() 
{
	PostMsgHelper( IDM_SELECTALL );
}

void CIESpyView::OnUpdateSpySelectAll(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyCopy() 
{
	PostMsgHelper( IDM_COPY );
}

void CIESpyView::OnUpdateSpyCopy(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyCut() 
{
	PostMsgHelper( IDM_CUT );
}

void CIESpyView::OnUpdateSpyCut(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnSpyPaste() 
{
	PostMsgHelper( IDM_PASTE );
}

void CIESpyView::OnUpdateSpyPaste(CCmdUI* pCmdUI) 
{
	CommonUpdateHandler( pCmdUI );
}

void CIESpyView::OnContextMenu(CWnd*, CPoint point) 
{
	CListCtrl & list = GetListCtrl();
	list.ScreenToClient( &point );
	if (list.HitTest( point ) != -1)
	{
		list.ClientToScreen( &point );
		CMenu menu;
		menu.LoadMenu( IDR_CONTEXTMENU );
		CMenu * pMenu = menu.GetSubMenu( 0 );
		ASSERT(pMenu);

		pMenu->TrackPopupMenu( TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON,
			point.x, point.y, ::AfxGetMainWnd() );
	}
}
